#pragma once
#include <array>
#include <vector>

struct Node
{
	int id;
	std::array<double, 3> cords;      
	bool isApex;
	Node(int, int, int, int, bool);
	Node();
	bool operator==(const Node&) const;
	bool operator<(const Node&) const;
	friend std::ostream& operator<<(std::ostream&, const Node&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<Node>&);
};

struct FiniteElement
{
	int id;
	int id_material;
	std::vector<int> nodes_id;
	friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<FiniteElement>&);
};

struct BoundaryFiniteElement
{
	int id;
	int border_id;
	std::vector<int> nodes_id;
	friend std::ostream& operator<<(std::ostream&, const BoundaryFiniteElement&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<BoundaryFiniteElement>&);
};

struct Edge {
	int f_id;
	int l_id;
	int c_id;
	Edge();
	Edge(int, int, int);
	bool operator==(const Edge&) const;
	bool operator<(const Edge&) const;
	void update(int);
};
