#pragma once
#include <string>
class MeshLoader
{
private:
	std::vector<Node> nodes;
	std::vector<FiniteElement> elements;
	std::vector<BoundaryFiniteElement> boundary_elements;
	int get_last_node_id();
public:

	virtual bool LoadMesh (const & std::string) = 0; 
	
	MeshLoader();
	void Print_Data();
	std::vector<Node>& get_Nodes();
	std::vector<FiniteElement>& get_FiniteElements();
	std::vector<BoundaryFiniteElement>& get_BoundaryElements();
	std::vector<FiniteElement>& find_Elements_by_nodes(int ,int ,int );
	std::vector<FiniteElement>& find_Elements_by_edge(int ,int);
	std::vector<Node>& find_Nodes_by_s_id(int );
	std::vector<FiniteElement>& find_Elements_by_material(int );
	std::vector<BoundaryFiniteElement>& find_Belements_by_b_id(int );
	void Transform_Elements();
	
	Node* get_node_by_id(int );
	std::vector<std::vector<Node>> get_nodes_neighbors();
};
